require 'json' 
 
package = JSON.parse(File.read(File.join(__dir__, 'package.json'))) 
 
Pod::Spec.new do |s| 
  s.name         = "RNShcConnector" 
  s.version      = package['version'] 
  s.summary      = package['description'] 
  s.description  = package['description'] 
  s.homepage     = package['homepage'] 
  s.license      = package['license'] 
  s.author       = package['author'] 
  s.platform     = :ios, "9.0" 
  s.source       = { :git => "git@src.codespring.ro:bosch/emma/react-native-shc-connector.git", :tag => "master" } 
  s.source_files = 'ios/**/*.{h,m}' 
  s.requires_arc = true 

  s.dependency "React" 

  s.subspec 'sh-connector-library-ios' do |ss|
    ss.vendored_frameworks = 'ios/frameworks/sh-connector-library-ios.framework'
    ss.resources = 'ios/resources/SH_Controller_Root_CA.der', 'ios/resources/SH_Server_Root_CA.der'

    ss.dependency 'SocketRocket'
    ss.dependency 'CocoaLumberjack' , '~> 3.4.1'
    ss.dependency 'OpenSSL', '1.0.2p'
  end
end