import { NativeEventEmitter, NativeModules } from 'react-native';

const { RNShcConnector } = NativeModules;

const emitter = new NativeEventEmitter(RNShcConnector);

RNShcConnector.addEventListener = (event, cb, context) => emitter.addListener(event, cb, context);

RNShcConnector.removeEventListener = (event) => emitter.removeAllListeners(event); 

export default RNShcConnector;

export const RNShcEventType = {
	ShcIdChangedResult: "RNSHC_ID_CHANGE_RESULT",
	PairingStatusChanged: "RNSHC_PARING_STATUS_CHANGED",
	PairingStatus: "RNSHC_PARING_STATUS",
	ConnectionLost: "RNSHC_CONNECTION_LOST",
	Connected: "RNSHC_CONNECTED",
	Disconnected: "RNSHC_DISCONNECTED"
}
