//
//  Copyright (c) 2015-2018 Robert Bosch Smart Home GmbH
//
//  All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString *const ShcConnectorErrorDomain;
extern NSString *const ShcHTTPErrorDomain;

// Error Domains for Connector Errors: Scribble
// Validation or Missing Errorcodes: 10100 - 10199
// Network related issues: 10200 - 1299
// Security related Issues: 10300 - 1399
// Miscellaneous Issues: 10900 - 10999
//
// Final output error enumeration:

NS_ENUM(NSUInteger)
{
    ShcConfigurationErrorSecretNotSet                        = 10100,
    ShcConfigurationErrorMacAddressNotValid                  = 10101,
    ShcConfigurationErrorIPAddressNotValid                   = 10102,
    ShcConfigurationErrorUserNameNotSet                      = 10103,
    ShcConfigurationErrorUserPasswordNotSet                  = 10104,
    ShcConfigurationErrorTermsAndConditionNotSet             = 10105,
    ShcConfigurationErrorCountryNotSet                       = 10106,
    ShcConfigurationErrorClientNameNotSet                    = 10107,
    ShcConfigurationErrorClientIDNotSet                      = 10108,
    ShcConfigurationErrorPrimaryRoleNotSet                   = 10109,
    ShcConfigurationErrorRolesNotSet                         = 10110,
    ShcConfigurationErrorDynamicRolesNotSet                  = 10111,
    ShcConfigurationErrorOSNotSet                            = 10112,
    ShcConfigurationErrorOSVersionNotSet                     = 10113,
    ShcConfigurationErrorAppVersionNotSet                    = 10114,
    ShcConfigurationErrorAlreadyClaimedOrPaired              = 10115,
    ShcConfigurationErrorDefaultConfigurationNotAvailable    = 10116,
    ShcImportErrorInvalidImportData                          = 10117,
    ShcConfigurationErrorNonceNotSet                         = 10118,
    ShcConfigurationErrorPairingIdNotSet                     = 10119,
    ShcConfigurationErrorInvalidPublicInformationData        = 10118,
    ShcConnectionErrorInvalidHTTPResponse                    = 10200,
    ShcConnectionErrorCancelled                              = 10201,
    ShcConnectionErrorTimedOut                               = 10202,
    ShcConnectionErrorCommunicationFailed                    = 10203,
    ShcConnectionErrorRemoteConnectionFailed                 = 10204,
    ShcNetworkErrorHomeWifiNotFound                          = 10205,
    ShcConnectionErrorNotAvailable                           = 10206,
    ShcRequestErrorRequestNotFound                           = 10207,
    ShcConnectionErrorUnknown                                = 10249,

    ShcLocatorErrorAlreadyLocating                           = 10250,
    ShcLocatorErrorCannotLocateMACAddress                    = 10251,
    ShcLocatorErrorCannotResolveAddress                      = 10252,
    ShcLocatorErrorDidStopUnexpectedly                       = 10253,
    ShcLocatorErrorNetServiceDidRemoveDuringResolve          = 10254,
    ShcLocatorErrorTimedOut                                  = 10255,

    ShcSecurityErrorCertificateCreation                      = 10300,
    ShcConnectionErrorBadClientCertificate                   = 10301,
    ShcConnectionErrorBadServerCertificate                   = 10302,
    ShcSecurityErrorIncompatibleATSParameters                = 10303,

    ShcFileManagerErrorFileNotFound                          = 10900,
    ShcJSONSerizationErrorInvalidJSON                        = 10950
};

@interface NSError (ShcConRepresentation)

- (BOOL)isHTTPError;
- (BOOL)isHTTPErrorWithStatusCode:(NSInteger)statusCode;
- (BOOL)isConnectorError;
- (BOOL)isConnectorErrorWithErrorCode:(NSUInteger)errorCode;

@end
