//
//  Copyright (c) 2015-2018 Robert Bosch Smart Home GmbH
//
//  All rights reserved.
//

#import <Foundation/Foundation.h>

@interface ShcImportDataHolder : NSObject

@property (nonatomic, readonly, copy) NSString* shcIPAdress;
@property (nonatomic, readonly, copy) NSString* shcMACAdress;
@property (nonatomic, readonly, copy) NSString* shcSecret;

@property (nonatomic, readonly, copy) NSString* remoteTunnelAddress;
@property (nonatomic, readonly, copy) NSString* remoteTunnelToken;

@property (nonatomic, readonly, copy) NSString* ssid;

@property (nonatomic, readonly, copy) NSString* deviceOrClientID;
@property (nonatomic, readonly, copy) NSString* clientCertificatePassword;
@property (nonatomic, readonly, copy) NSData* certificateData;

- (instancetype)initWithIPAddress:(NSString*)shcIPAddress
                    shcMACAddress:(NSString*)shcMACAddress
                        shcSecret:(NSString*)shcSecret
              remoteTunnelAddress:(NSString*)remoteTunnelAddress
                remoteTunnelToken:(NSString*)remoteTunnelToken
                             ssid:(NSString*)ssid
                 deviceOrClientID:(NSString*)deviceOrClientID
        clientCertificatePassword:(NSString*)clientCertificatePassword
                  certificateData:(NSData*)certificateData;

- (BOOL)isValid;
- (BOOL)isValidForRemoteCommunication;

- (instancetype) init UNAVAILABLE_ATTRIBUTE;

@end
