//
//  RequestService.h
//  RNShcConnector
//
//  Created by Beata Brassai on 16/07/2018.
//  Copyright © 2018 Bosch TT. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <ShcConRepresentation.h>
#import "NotificationHandler.h"

@interface RequestService : NSObject
@property(nonatomic, weak, readwrite) id<NotificationHandler> notificationHandler;

typedef void (^RestSuccessBlock)( NSString* _Nullable response );
typedef void (^RestFailureBlock)( NSError* _Nonnull error, id _Nullable rawResponse );

- (nullable instancetype)initWithConRepresentation:(nonnull ShcConRepresentation*)conRepresentation notificationHandler: (nonnull id<NotificationHandler>)notificationHandler;
- (void)pairWithNonce:(nonnull NSString*)nonce pairingId:(nonnull NSString*)pairingId success:(nullable RestSuccessBlock)successBlock failure:(nullable RestFailureBlock)failureBlock;

- (void)sendGetByUrl:(nonnull NSString*)url successBlock:(nullable RestSuccessBlock)successBlock failureBlock:(nullable RestFailureBlock)failureBlock;
- (void)sendPutByUrl:(nonnull NSString*)url body:(nullable NSString*)body successBlock:(nullable RestSuccessBlock)successBlock failureBlock:(nullable RestFailureBlock)failureBlock;
- (void)sendPatchByUrl:(nonnull NSString*)url body:(nullable NSString*)body successBlock:(nullable RestSuccessBlock)successBlock failureBlock:(nullable RestFailureBlock)failureBlock;

@end /* RequestService.h */
