package com.bosch.tt.privacypolicy.rn.ui;

import com.bosch.tt.privacypolicy.ui.CountrySelector;
import com.bosch.tt.privacypolicy.rn.util.PrivacyPolicyEvent;
import com.facebook.react.common.MapBuilder;
import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;

import java.util.Map;

import javax.annotation.Nullable;

public class CountrySelectorViewManager extends SimpleViewManager<CountrySelector> {

	private static final String REACT_CLASS = "RNCountrySelector";

	@Override
	public String getName() {
		return REACT_CLASS;
	}

	@Override
	protected CountrySelector createViewInstance(final ThemedReactContext reactContext) {
		return new ReactCountrySelector(reactContext);
	}

	/**
	 * This method maps the "ON_COUNTRY_SELECTED" event to JS "onCountrySelected" callback function
	 */
	@Nullable
	@Override
	public Map<String, Object> getExportedCustomDirectEventTypeConstants() {
		return MapBuilder.<String, Object>builder()
			.put(PrivacyPolicyEvent.ON_COUNTRY_SELECTED.toString(), MapBuilder.of("registrationName", "onCountrySelected"))
			.build();
	}
}
