package com.bosch.tt.privacypolicy.rn.ui;

import android.content.Context;

import com.bosch.tt.privacypolicy.ui.CountrySelector;

/**
 * This child class is necessary, because when an update occurs on the custom view which will affect the view's size, the update will not be visible.
 * Should override the "requestLayout" method and set the new layout according to changes.
 *
 * See issues:
 *  https://github.com/facebook/react-native/issues/4990
 *  https://stackoverflow.com/questions/39836356/react-native-resize-custom-ui-component
 */
public class ReactCountrySelector extends CountrySelector {

    private final Runnable measureAndLayout = new Runnable() {
        @Override
        public void run() {
            measure(
                MeasureSpec.makeMeasureSpec(getWidth(), MeasureSpec.EXACTLY),
                MeasureSpec.makeMeasureSpec(getHeight(), MeasureSpec.EXACTLY)
            );
            layout(getLeft(), getTop(), getRight(), getBottom());
        }
    };

    public ReactCountrySelector(Context context) {
        super(context);
    }

    @Override
    public void requestLayout() {
        super.requestLayout();
        post(measureAndLayout);
    }

}
