//
//  PrivacyManager.h
//  RNPrivacyComponent
//
//  Created by István Bege on 31/10/2018.
//  Copyright (C) 2018, Bosch Thermotechnik GmbH. All rights reserved.
//

//  Singleton class which holds the necessary TTPPrivacyProvider object instance and country objects.

#import <Foundation/Foundation.h>

#import <TTPPrivacyProvider.h>
#import <TTPPreviewValueProvider.h>
#import <TTPProductionValueProvider.h>

@interface PrivacyManager : NSObject {
    TTPPrivacyProvider* privacyProvider;
    TTPCountry* selectedCountry;
    NSArray<TTPCountry*>* supportedCountries;
}

@property (nonatomic, readonly) TTPPrivacyProvider* privacyProvider;
@property (nonatomic, retain) TTPCountry* selectedCountry;
@property (nonatomic, retain) NSArray<TTPCountry*>* supportedCountries;

+ (PrivacyManager*)getInstance;

- (void)initProviderWithLeanIX:(nonnull NSString*)leanIX productionMode:(BOOL)productionMode;

- (TTPPrivacyProvider*)getTermsOfUseProvider;

@end
