//
//  RNTTPPrivacyComponent.m
//  RNPrivacyComponent
//
//  Created by István Bege on 01/11/2018.
//  Copyright (C) 2018, Bosch Thermotechnik GmbH. All rights reserved.
//

#import "RNTTPrivacyComponent.h"
#import "Assembler.h"

@implementation RNTTPrivacyComponent

- (id) init {
    self = [super init];
    if (self) {
        self.delegate = self;
    }
    return self;
}

- (void)onLoadFinishedWithDocument:(TTPDocument *)document error:(NSString *)error {
    self.onDocumentLoaded([Assembler createDocumentDTO:document]);
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
    float bottomEdge = scrollView.contentOffset.y + scrollView.frame.size.height;
    if (bottomEdge >= scrollView.contentSize.height) {
        self.onScrollEnded(nil);
    }
}

- (void)setActivityIndicatorViewStyle:(UIActivityIndicatorViewStyle)activityIndicatorViewStyle {
    [super setActivityIndicatorViewStyle:activityIndicatorViewStyle];
}

@end
